<?php
/**
 * @name          : Joomla HD Video Share
 * @version	  : 1.0
 * @package       : apptha
 * @since         : Joomla 1.5
 * @author        : Apptha - http://www.apptha.com
 * @copyright     : Copyright (C) 2011 Powered by Apptha
 * @license       : http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @abstract      : Contus HD Video Share plugin for Joomla Social integration
 * @Creation Date : December 2013
 * @Modified Date : December 2013
 * */
## No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');

class plgSystemConnectVideoshare extends JPlugin {
    
    ## constructor method
    public function plgSystemConnectVideoshare(&$subject, $config) {
        parent::__construct($subject, $config);
    }
    
    public function onAfterDispatch() {
        
    }
    
    public function onAfterRender(){

    }
    
     public function onAfterRoute() {

        $app                    = JFactory::getApplication();
        $db                     = JFactory::getDBO();
        ## Get userid
        $user                   = JFactory::getUser();
        $userId                 = $user->id;
            ## Check whether page is frontend
            if ($app->isSite() && $userId != 0) {
                
                    $query                  = "SELECT hd_video_id FROM #__community_videos ORDER BY id DESC LIMIT 1";
                    $db->setQuery($query);
                    $db->query();
                    $hd_video_id              = $db->loadResult();
                   
                        ## Insert into videoshare tables
                        if ($hd_video_id == 0 ) {
                            $this->updatevideosharetable();
                        }
                        ## Insert into jomsocial tables
                            $this->updateVideos();
                    
                   $this->updateComments();
            }
     }
     ## Function to insert values into videoshare table
     function updatevideosharetable() {
         
        $db                         = JFactory::getDBO();
        ## Define DS
        if(!defined('DS')) { 
            define('DS',DIRECTORY_SEPARATOR); 
        }
        ## Get the userid
        $user                       = JFactory::getUser();
        $userId                     = $user->id;
        ## Get Current date
        $currentTime                = JFactory::getDate();

            $getcommunityvideos         = "SELECT path,id,description,title,type,thumb FROM #__community_videos 
                                        WHERE published=1 
                                        ORDER BY id DESC 
                                        LIMIT 1";
            $db->setQuery($getcommunityvideos);
            $videosResult               = $db->loadObject();

            $jomSocial_videoid          = $videosResult->id;                ## Get video ID from community videos table
            $jomSocial_videodesc        = $videosResult->description;       ## Get video description from community videos table
            $video_title                = $videosResult->title;             ## Get video title from community videos table
            $videourl                   = $videosResult->path;              ## Get video path from community videos table
            $video_type                 = $videosResult->type;              ## Get video type from community videos table
            $video_thumb                = $videosResult->thumb;             ## Get video thumb from community videos table

            if($video_type != 'file') {
                    $fileoption         = 'Youtube';
                    if(strpos($videourl,'youtube') > 0) {                   ## If video is youtube url
                            $imgstr     = explode("v=", $videourl);
                            $imgval     = explode("&", $imgstr[1]);
                            $previewurl = "http://img.youtube.com/vi/" . $imgval[0] . "/maxresdefault.jpg";
                            $img        = "http://img.youtube.com/vi/" . $imgval[0] . "/mqdefault.jpg";
                    } else if(strpos($videourl,'youtu.be') > 0) {           ## If video is youtube url
                            $imgstr     = explode("/", $videourl);
                            $previewurl = "http://img.youtube.com/vi/" . $imgstr[3] . "/maxresdefault.jpg";
                            $img        = "http://img.youtube.com/vi/" . $imgstr[3] . "/mqdefault.jpg";
                            $videourl   = "http://www.youtube.com/watch?v=".$imgstr[3];
                    } else if(strpos($videourl,'vimeo') > 0) {              ## If video is vimeo url
                        $split          = explode("/",$videourl);
                        if( ini_get('allow_url_fopen') ) {
                               $doc     = new DOMDocument();
                               $doc->load('http://vimeo.com/api/v2/video/'.$split[3].'.xml');
                               $videotags       = $doc->getElementsByTagName('video');
                               foreach ($videotags as $videotag)
                               {
                                       $imgnode = $videotag->getElementsByTagName('thumbnail_medium');
                                       $img     = $imgnode->item(0)->nodeValue;
                               }
                       }else{
                               $url     = "http://vimeo.com/api/v2/video/" . $split[3] . ".xml";
                               $curl    = curl_init($url);
                               curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
                               $result  = curl_exec($curl);
                               curl_close($curl);
                               $xml     = simplexml_load_string($result);
                               $img     = $xml->video->thumbnail_medium;
                       }
                    } else if(strpos($videourl,'dailymotion') > 0) {            ## If video is dailymotion url
                        $split          = explode("/",$videourl);
                        $split_id       = explode("_",$split[4]);
                        $img            = $previewurl = 'http://www.dailymotion.com/thumbnail/video/'.$split_id[0];
                    } else if(strpos($videourl,'viddler') > 0) {                ## If video is viddler url
                            $imgstr     = explode("/", $videourl);
                            $img        = $previewurl = "http://cdn-thumbs.viddler.com/thumbnail_2_" . $imgstr[4] . "_v1.jpg";
                    }
            } else {                    ## If uploaded video
                $fileoption = 'File';
                $split                  = explode("/",$videourl);
                $video_name             = $split[3];
                copy(JPATH_SITE.DS.$videourl,JPATH_SITE.DS.'components'.DS.'com_contushdvideoshare'.DS.'videos'.DS.$video_name);
                $videourl               = $video_name;
                if( !empty($video_thumb) && $video_thumb != NULL ){
                    $img                = $previewurl = $video_thumb;
                } else {
                    $img                = 'default_thumb.jpg';
                    $previewurl         = 'default_preview.jpg';
                }
            }
                    ## Generate seo title for video share table
                    $seo_Title                  = strtolower(stripslashes(str_replace("+","",$video_title)));
                    $rmv_space_Title            = preg_replace('/[&:\s]+/i', '-', $seo_Title);
                    $rmv_spl_chr_Title          = preg_replace('/[#!@$%^.,:;\/&*(){}\"\'\[\]<>|?]+/i', '', $rmv_space_Title);
                    $seoTitle                   = preg_replace('/---|--+/i', '-', $rmv_spl_chr_Title);
                    ## Get category id from videoshare table
                    $getcatidquery              = "SELECT id FROM `#__hdflv_category` 
                                                ORDER BY id DESC 
                                                LIMIT 1";
                    $db->setQuery($getcatidquery);
                    $db->query();
                    $catid                      = $db->loadResult();
                    ## Get user group id
                    $getusergroupid             = "SELECT group_id FROM `#__user_usergroup_map` WHERE user_id = '$userId' LIMIT 1";
                    $db->setQuery($getusergroupid);
                    $db->query();
                    $usergroupid                = $db->loadResult();

                        if(!empty($video_title)) {              ## Allow only new video availbale in community table
                            ## Update Videoshare tables
                            $insertquery                = "INSERT INTO #__hdflv_upload (published,title,description,memberid,seotitle,streameroption,filepath,videourl,thumburl,previewurl,hdurl,playlistid,created_date,addedon,usergroupid)
                                                        VALUES (1,'$video_title','$jomSocial_videodesc','$userId','$seoTitle','','$fileoption','$videourl','$img','$previewurl','','$catid','$currentTime','$currentTime','$usergroupid')";
                            $db->setQuery($insertquery);
                            $db->query();
                            $last_inserted_videoId      = $db->insertid();
                            
                            $insertcatquery             = "INSERT INTO #__hdflv_video_category (vid,catid)
                                                        VALUES ('$last_inserted_videoId','$catid')";
                            $db->setQuery($insertcatquery);
                            $db->query();
                            ## Update Video id in community table
                            $query                      = "UPDATE #__community_videos 
                                                        SET hd_video_id= '$last_inserted_videoId'
                                                        WHERE id=$jomSocial_videoid";
                            $db->setQuery($query);
                            $db->query();
                        }
                    
     }
     ## Function to insert values into Jomsocial video table
      function updateVideos() {

        $db                     = JFactory::getDBO();
        $user                   = JFactory::getUser();
        $userId                 = $user->id;
        $duration               = '';
        $currentTime            = JFactory::getDate();
        if(!defined('DS')) { 
            define('DS',DIRECTORY_SEPARATOR); 
        }
        ## Get the videos from the video share tables.
        
        $query                  = "SELECT * FROM #__hdflv_upload 
                                   WHERE published=1 
                                   ORDER BY id DESC 
                                   LIMIT 1";
        $db->setQuery($query);
        $videosResult           = $db->loadObject();
         
        if (!empty($videosResult)) {
            ## If there is no videos folder,create new
            $directory          = JPATH_SITE . "/images/videos/";
            
            if (!is_dir($directory)) {
                mkdir($directory);
            }
            
            ## If there is no folder for the userid,create new
            $dir                = JPATH_SITE . "/images/videos/" . $userId;
            
            if (!is_dir($dir)) {
                mkdir($dir);
            }
            
            ## If there is no originalvideos folder,create new
            $ori_directory          = JPATH_SITE . "/images/originalvideos/";
            
            if (!is_dir($ori_directory)) {
                mkdir($ori_directory);
            }
            
            ## If there is no folder for the userid,create new
            $ori_dir                = JPATH_SITE . "/images/originalvideos/" . $userId;
            
            if (!is_dir($ori_dir)) {
                mkdir($ori_dir);
            }
            
            ## If there is no thumb folder,create new
            $subDirectory       = JPATH_SITE . "/images/videos/" . $userId . "/thumbs";
            
            if (!is_dir($subDirectory)) {
                mkdir($subDirectory);
            }
            
            
            ## Get video url and type from result
            $filetype               = $videosResult->filepath;
            $url                    = $videosResult->videourl;
            $thumburl               = $videosResult->thumburl;
            $title                  = $videosResult->title;
            $vidId                  = NULL;
            if($filetype != 'File') {           ## If file type is url method
                
                if(strstr($url,'vimeo')){
                    $type           = 'vimeo';
                } else if(strstr($url,'youtube')){
                     $type          = 'Youtube';
                } else if(strstr($url,'dailymotion')){
                     $type          = 'dailymotion';
                } else if(strstr($url,'viddler')){
                     $type          = 'viddler';
                } else {
                     $type          = '';
                }

                 if ($type == 'Youtube') {      ## If youtube video
                    ## Get the video id
                    $youtubeUrl     = explode("=", $url);

                    ## Get the youtube image for the particular video
                    $youImage       = file_get_contents("http://img.youtube.com/vi/" . $youtubeUrl[1] . "/0.jpg");
                    $imageName      = JPATH_SITE . "/images/videos/" . $userId . '/' . 'thumbs/' . $youtubeUrl[1] . '.jpg';

                    file_put_contents($imageName, $youImage);
                    $image          = '/images/videos/' . $userId . '/' . 'thumbs/' . $youtubeUrl[1] . '.jpg';

                    $vidId          = $youtubeUrl[1];
                    $urll           = "http://gdata.youtube.com/feeds/api/videos/" . $vidId;
                    $doc            = new DOMDocument;
                    $doc->load($urll);
                    $title          = $doc->getElementsByTagName("title")->item(0)->nodeValue;
                    $duration       = $doc->getElementsByTagName('duration')->item(0)->getAttribute('seconds');

                } else if($type == 'vimeo'){     ## If vimeo video
                    $vidarray       = explode("/", $url);
                    $vidId          = $vidarray[3];
                    $split          = explode("/", $url);

                    ## Check whether furl is open otherwise use the curl method

                    if (ini_get('allow_url_fopen')) {       ## If allow_url_fopen enabled in server

                        $doc        = new DOMDocument();
                        $doc->load('http://vimeo.com/api/v2/video/' . $split[3] . '.xml');
                        $videotags  = $doc->getElementsByTagName('video');
                        foreach ($videotags as $videotag) {
                            $imgnode    = $videotag->getElementsByTagName('thumbnail_medium');
                            $img        = $imgnode->item(0)->nodeValue;
                        }
                        $xml        = simplexml_load_file('http://vimeo.com/api/v2/video/' . $split[3] . '.xml');
                        foreach ($xml->video as $video) {
                            $title      = $video->title;
                            $duration   = $video->duration;
                        }

                    } else {                                ## If allow_url_fopen disable in server use CURL

                        $url            = "http://vimeo.com/api/v2/video/" . $split[3] . ".xml";
                        $curl           = curl_init($url);
                        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
                        $result         = curl_exec($curl);
                        curl_close($curl);
                        $xml            = simplexml_load_string($result);
                        $img            = $xml->video->thumbnail_medium;

                    }

                    $vimImage           = file_get_contents($img);
                    $image              = JPATH_SITE . "/images/videos/" . $userId . '/' . 'thumbs/' . $vidId . '.jpg';
                    file_put_contents($image, $vimImage);
                    $image              = "/images/videos/" . $userId . '/' . 'thumbs/' . $vidId . '.jpg';

                } else if($type == 'dailymotion'){          ## If dailymotion video

                    $split              = explode("/",$url);
                    $split_id           = explode("_",$split[4]);
                    $json               = file_get_contents("https://api.dailymotion.com/video/$split_id[0]?fields=thumbnail_url");
                    $decod_values       = json_decode($json, true);
                    $image              = $decod_values['thumbnail_url'];
                    $dailyImage         = file_get_contents($image);
                    $imageName          = JPATH_SITE . "/images/videos/" . $userId . '/' . 'thumbs/' . $split_id[0] . '.jpg';
                    file_put_contents($imageName, $dailyImage);
                    $image              = '/images/videos/' . $userId . '/' . 'thumbs/' . $split_id[0] . '.jpg';
                    $vidId              = $split[4];
                } else if($type == 'viddler'){              ## If viddler video

                    $split              = explode("/",$url);
                    $image              = "http://cdn-thumbs.viddler.com/thumbnail_2_" . $split[4] . "_v1.jpg";
                    $viddlerImage       = file_get_contents($image);
                    $imageName          = JPATH_SITE . "/images/videos/" . $userId . '/' . 'thumbs/' . $split[4] . '.jpg';
                    file_put_contents($imageName, $viddlerImage);
                    $image              = '/images/videos/' . $userId . '/' . 'thumbs/' . $split[4] . '.jpg';
                    $vidId              = $split[4];
                }
            } else {                                        ## If uploaded video
                $type = 'file';
                copy(JPATH_SITE.DS.'components'.DS.'com_contushdvideoshare'.DS.'videos'.DS.$thumburl,JPATH_SITE.DS.'images'.DS.'videos'.DS.$userId.DS.'thumbs'.DS.$thumburl);
                copy(JPATH_SITE.DS.'components'.DS.'com_contushdvideoshare'.DS.'videos'.DS.$url,JPATH_SITE.DS.'images'.DS.'originalvideos'.DS.$userId.DS.$url);
                $url    = 'images/originalvideos/'.$userId.'/'.$url;
                $image  = 'images/videos/'.$userId.'/thumbs/'.$thumburl;
            }
            if(!empty($type)) {
            ## To check the videos already in jomsocial or not.
            $query                  = "SELECT * FROM #__community_videos 
                                       WHERE hd_video_id=" . $videosResult->id;
            $db->setQuery($query);
            $db->query();
            $rowsCount              = $db->loadResult();

                ## To insert into the jomsocial tables
                if (empty($rowsCount)) {

                    $query              = "INSERT INTO #__community_videos(title,type,video_id,description,creator,creator_type,created,permissions,category_id,published,duration,status,thumb,path,storage,latitude,longitude,hd_video_id) 
                                           VALUES ('" . $title . "','" . $type . "','" . $vidId . "','" . '' . "','" . $userId . "','user','".$currentTime."',0,1,1,'" . $duration . "','ready','" . $image . "','" . $url . "','file','255.000000','255.000000','" . $videosResult->id . "')";
                    $db->setQuery($query);
                    $db->query();
                    $videoId            = $db->insertid();

                    ## Insert the video activity in the video table  
                    $query              = "INSERT INTO #__community_activities(actor,app,cid,created,points,latitude,longitude,comment_id,comment_type,like_id,like_type) 
                                           VALUES ('" . $userId . "','videos','" . $videoId . "','".$currentTime."','1','255.000000','255.000000','" . $videoId . "','videos','" . $videoId . "','videos')";
                    $db->setQuery($query);
                    $db->query();
                }
            }
         }
      }
      
      ## Function to update Comments
      function updateComments() {
          
        $db             = JFactory::getDBO();
        $currentTime    = JFactory::getDate();
        
        ## Selct the Comments from Comment table
        
        $query          = "SELECT * FROM #__hdflv_comments";
        $db->setQuery($query);
        $result         = $db->loadObjectList();
        
           foreach ($result as $key) {
                $query                  = "SELECT * FROM #__community_wall WHERE comment_id=". $key->id;
                $query                  = $db->setQuery($query);
                $db->query();
                $rowsCount              = $db->getNumRows();
                ## GEt video comment id and update in community table
                if ($rowsCount == 0) {
                    $query         = "SELECT id,creator 
                                     FROM #__community_videos 
                                     WHERE hd_video_id='".$key->videoid."'";
                    $query         = $db->setQuery($query);
                    $videoId       = $db->loadObjectlist();
                    if(!empty($videoId)){
                           $query = "INSERT INTO #__community_wall(contentid,post_by,ip,comment,date,published,type,comment_id)
                                    VALUES('".$videoId[0]->id."','".$videoId[0]->creator."','$ip','" . $key->message . "','".$currentTime."',1,'videos',$key->id)";
                           $db->setQuery($query);
                           $db->query();
                      }
                }
           }
      }
    
}
?>